require 'sketchup.rb' 
require 'extensions.rb' 
Sketchup::require File.dirname(__FILE__) + '/Projection/projection'

#
#                                        MENU ITEMS
#

if !file_loaded?("projection_extension.rb")

  #Projection toolbar
  #
  gp_project_tb = UI::Toolbar.new("Projections")
  #Guides eraser
  cmd100 = UI::Command.new(("Erase guides")) { xlinesEraser()}
  cmd100.small_icon = "Projection/Xlines_erase_Small.png"
  cmd100.large_icon = "Projection/Xlines_erase_Large.png"
  cmd100.tooltip = "Erase guides created by the plugin or by SketchUp"
  gp_project_tb.add_item(cmd100)
  #Add Cpoint
  cmd0 = UI::Command.new(("Insert construction point")) { Sketchup.active_model.select_tool(AddCpointTool.new) }
  cmd0.small_icon = "Projection/Const_Point_Small.png"
  cmd0.large_icon = "Projection/Const_Point_Large.png"
  cmd0.tooltip = "Insert guide point"
  gp_project_tb.add_item(cmd0)
  #Add guides through lines
  cmd8 = UI::Command.new(("Guide through line")) { Sketchup.active_model.select_tool(XLinesThrougLinesTool.new) }
  cmd8.small_icon = "Projection/Xlines_through_lines_Small.png"
  cmd8.large_icon = "Projection/Xlines_through_lines_Large.png"
  cmd8.tooltip = "Insert a guide through each line of selection"
  gp_project_tb.add_item(cmd8)
  #Add normal guide through face
  cmd83 = UI::Command.new(("Guide normal through face")) { Sketchup.active_model.select_tool(XLineNormalThrougFaceTool.new) }
  cmd83.small_icon = "Projection/Xlines_normals_Small.png"
  cmd83.large_icon = "Projection/Xlines_normals_Large.png"
  cmd83.tooltip = "Insert a guide normal to face at point"
  gp_project_tb.add_item(cmd83)
  #Add normal guide through intersections of faces
  cmd84 = UI::Command.new(("Guide through intersections of faces")) { xLineThrougIntersectionsFaces() }
  cmd84.small_icon = "Projection/Xlines_intersections_Small.png"
  cmd84.large_icon = "Projection/Xlines_intersections_Large.png"
  cmd84.tooltip = "Insert guides through intersections of selected faces"
  gp_project_tb.add_item(cmd84)
  #Add guides at measured intervals
  cmd81 = UI::Command.new(("Guides at measured intervals")) { Sketchup.active_model.select_tool(XLinesAtIntervalsTool.new) }
  cmd81.small_icon = "Projection/Xlines_intervals_Small.png"
  cmd81.large_icon = "Projection/Xlines_intervals_Large.png"
  cmd81.tooltip = "Insert guides at intervals, starting from an edge"
  gp_project_tb.add_item(cmd81)
  #Add guides at equal intervals
  cmd82 = UI::Command.new(("Guides at divisions")) { Sketchup.active_model.select_tool(XLinesAtDivisionsTool.new) }
  cmd82.small_icon = "Projection/Xlines_divisions_Small.png"
  cmd82.large_icon = "Projection/Xlines_divisions_Large.png"
  cmd82.tooltip = "Insert guides at divisions, between two points"
  gp_project_tb.add_item(cmd82)
  #Add guides at radial intervals
  cmd821 = UI::Command.new(("Radial Guides")) { Sketchup.active_model.select_tool(XLinesAtRadialsTool.new) }
  cmd821.small_icon = "Projection/Xlines_radials_Small.png"
  cmd821.large_icon = "Projection/Xlines_radials_Large.png"
  cmd821.tooltip = "Insert guides at regular angles from selected line"
  gp_project_tb.add_item(cmd821)
 #Add guides as a rectangle
  cmd822 = UI::Command.new(("Rectangle Guides")) { Sketchup.active_model.select_tool(XLinesRectangleTool.new) }
  cmd822.small_icon = "Projection/Xlines_rectangle_Small.png"
  cmd822.large_icon = "Projection/Xlines_rectangle_Large.png"
  cmd822.tooltip = "Insert guides at borders of a rectangle"
  gp_project_tb.add_item(cmd822)
  #Project point on line or face
  cmd1 = UI::Command.new(("Point perpendicular to line/face")) { Sketchup.active_model.select_tool(ProjectCpointTool.new) }
  cmd1.small_icon = "Projection/Point_sur_plan_Small.png"
  cmd1.large_icon = "Projection/Point_sur_plan_Large.png"
  cmd1.tooltip = "Project  guide point perpendicular to  line or face"
  gp_project_tb.add_item(cmd1)
  #Project line(s) as cpoints on face(s)
  cmd11 = UI::Command.new(("Project  lines/guides as guide points on face(s)")) { cpointAtLineFaceIntersection() }
  cmd11.small_icon = "Projection/Const_Point_sur_plan_Small.png"
  cmd11.large_icon = "Projection/Const_Point_sur_plan_Large.png"
  cmd11.tooltip = "Add guide points at the intersection of each face's plane and each line"
  gp_project_tb.add_item(cmd11)
  #Project lines on plane
  cmd2 = UI::Command.new(("Lines perpendicular to faces")) { Sketchup.active_model.select_tool(ProjectLinesOnPlaneTool.new) }
  cmd2.small_icon = "Projection/Lignes_sur_plan_Small.png"
  cmd2.large_icon = "Projection/Lignes_sur_plan_Large.png"
  cmd2.tooltip = "Project line(s) perpendicular to face(s)"
  gp_project_tb.add_item(cmd2)
  #Project faces perpendicular to plane
  cmd3 = UI::Command.new(("Faces perpendicular to face")) { Sketchup.active_model.select_tool(ProjectFacesOnPlaneTool.new) }
  cmd3.small_icon = "Projection/Faces_sur_plan_Small.png"
  cmd3.large_icon = "Projection/Faces_sur_plan_Large.png"
  cmd3.tooltip = "Project faces perpendicular to face"
  gp_project_tb.add_item(cmd3)
  #Project faces on plane along vector
  cmd4 = UI::Command.new(("Faces to plane along vector")) { Sketchup.active_model.select_tool(ProjectFacesAlongVectorTool.new) }
  cmd4.small_icon = "Projection/Faces_sur_plan_vecteur_Small.png"
  cmd4.large_icon = "Projection/Faces_sur_plan_vecteur_Large.png"
  cmd4.tooltip = "Project faces on face along vector"
  gp_project_tb.add_item(cmd4)
  #Push-pull along vector
  cmd5 = UI::Command.new(("Push-Pull faces along vector")) { Sketchup.active_model.select_tool(PushpullFacesAlongVectorTool.new) }
  cmd5.small_icon = "Projection/Pousser-tirer_vecteur_Small.png"
  cmd5.large_icon = "Projection/Pousser-tirer_vecteur_Large.png"
  cmd5.tooltip = "Push-Pull faces along vector"
  gp_project_tb.add_item(cmd5)
  #Push-pull along their normals
  cmd6 = UI::Command.new(("Push-Pull faces along their normals")) { Sketchup.active_model.select_tool(ProjectPushpullFacesAlongNormalsTool.new) }
  cmd6.small_icon = "Projection/Pousser-tirer_normales_Small.png"
  cmd6.large_icon = "Projection/Pousser-tirer_normales_Large.png"
  cmd6.tooltip = "Push-Pull faces along their normals"
  gp_project_tb.add_item(cmd6)
  #Extrude lines along vector
  cmd7 = UI::Command.new(("Extrude lines")) { Sketchup.active_model.select_tool(ExtrudeLinesTool.new) }
  cmd7.small_icon = "Projection/Extruder_lignes_Small.png"
  cmd7.large_icon = "Projection/Extruder_lignes_Large.png"
  cmd7.tooltip = "Extrude lines along vector"
  gp_project_tb.add_item(cmd7)
  
  ### submenu
  sub=UI.menu("Tools").add_submenu("Projections")
  sub.add_item(cmd100)
  sub.add_item(cmd0)
  sub.add_item(cmd8)
  sub.add_item(cmd83)
  sub.add_item(cmd84)
  sub.add_item(cmd81)
  sub.add_item(cmd82)
  sub.add_item(cmd821)
  sub.add_item(cmd822)
  sub.add_item(cmd1)
  sub.add_item(cmd11)
  sub.add_item(cmd2)
  sub.add_item(cmd3)
  sub.add_item(cmd4)
  sub.add_item(cmd5)
  sub.add_item(cmd6)
  sub.add_item(cmd7)
  ###

end

file_loaded("projection_extension.rb")
